diff --git a/packages/code-generator/src/plugins/project/constants.ts b/packages/code-generator/src/plugins/project/constants.ts
index d274499b4..08870e507 100644
--- a/packages/code-generator/src/plugins/project/constants.ts
+++ b/packages/code-generator/src/plugins/project/constants.ts
@@ -8,6 +8,7 @@ import {
   ICodeStruct,
   IProjectInfo,
 } from '../../types';
+import Scope from '../../utils/Scope';
 
 const pluginFactory: BuilderComponentPluginFactory<unknown> = () => {
   const plugin: BuilderComponentPlugin = async (pre: ICodeStruct) => {
@@ -16,35 +17,39 @@ const pluginFactory: BuilderComponentPluginFactory<unknown> = () => {
     };
 
     const ir = next.ir as IProjectInfo;
-    if (ir.constants) {
-      const constantStr = generateCompositeType(ir.constants);
+    const scope = Scope.createRootScope();
+    const constantStr = generateCompositeType(ir.constants || {}, scope);
 
-      next.chunks.push({
-        type: ChunkType.STRING,
-        fileType: FileType.JS,
-        name: COMMON_CHUNK_NAME.FileVarDefine,
-        content: `
-          const constantConfig = ${constantStr};
-        `,
-        linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport, COMMON_CHUNK_NAME.InternalDepsImport],
-      });
+    next.chunks.push({
+      type: ChunkType.STRING,
+      fileType: FileType.JS,
+      name: COMMON_CHUNK_NAME.FileVarDefine,
+      content: `
+        const __$$constants = (${constantStr});
+      `,
+      linkAfter: [
+        COMMON_CHUNK_NAME.ExternalDepsImport,
+        COMMON_CHUNK_NAME.InternalDepsImport,
+        COMMON_CHUNK_NAME.ImportAliasDefine,
+      ],
+    });
 
-      next.chunks.push({
-        type: ChunkType.STRING,
-        fileType: FileType.JS,
-        name: COMMON_CHUNK_NAME.FileExport,
-        content: `
-          export default constantConfig;
-        `,
-        linkAfter: [
-          COMMON_CHUNK_NAME.ExternalDepsImport,
-          COMMON_CHUNK_NAME.InternalDepsImport,
-          COMMON_CHUNK_NAME.FileVarDefine,
-          COMMON_CHUNK_NAME.FileUtilDefine,
-          COMMON_CHUNK_NAME.FileMainContent,
-        ],
-      });
-    }
+    next.chunks.push({
+      type: ChunkType.STRING,
+      fileType: FileType.JS,
+      name: COMMON_CHUNK_NAME.FileExport,
+      content: `
+        export default __$$constants;
+      `,
+      linkAfter: [
+        COMMON_CHUNK_NAME.ExternalDepsImport,
+        COMMON_CHUNK_NAME.InternalDepsImport,
+        COMMON_CHUNK_NAME.ImportAliasDefine,
+        COMMON_CHUNK_NAME.FileVarDefine,
+        COMMON_CHUNK_NAME.FileUtilDefine,
+        COMMON_CHUNK_NAME.FileMainContent,
+      ],
+    });
 
     return next;
   };
diff --git a/packages/code-generator/src/plugins/project/framework/icejs/plugins/entry.ts b/packages/code-generator/src/plugins/project/framework/icejs/plugins/entry.ts
index 0cf3918a7..b5dc2d8f8 100644
--- a/packages/code-generator/src/plugins/project/framework/icejs/plugins/entry.ts
+++ b/packages/code-generator/src/plugins/project/framework/icejs/plugins/entry.ts
@@ -6,7 +6,6 @@ import {
   ChunkType,
   FileType,
   ICodeStruct,
-  IProjectInfo,
 } from '../../../../../types';
 
 const pluginFactory: BuilderComponentPluginFactory<unknown> = () => {
@@ -15,8 +14,6 @@ const pluginFactory: BuilderComponentPluginFactory<unknown> = () => {
       ...pre,
     };
 
-    const ir = next.ir as IProjectInfo;
-
     next.chunks.push({
       type: ChunkType.STRING,
       fileType: FileType.JS,
@@ -34,10 +31,10 @@ const pluginFactory: BuilderComponentPluginFactory<unknown> = () => {
       content: `
         const appConfig = {
           app: {
-            rootId: '${ir.config.targetRootID}',
+            rootId: 'app',
           },
           router: {
-            type: '${ir.config.historyMode}',
+            type: 'hash',
           },
         };
         createApp(appConfig);
@@ -45,6 +42,7 @@ const pluginFactory: BuilderComponentPluginFactory<unknown> = () => {
       linkAfter: [
         COMMON_CHUNK_NAME.ExternalDepsImport,
         COMMON_CHUNK_NAME.InternalDepsImport,
+        COMMON_CHUNK_NAME.ImportAliasDefine,
         COMMON_CHUNK_NAME.FileVarDefine,
         COMMON_CHUNK_NAME.FileUtilDefine,
       ],
diff --git a/packages/code-generator/src/plugins/project/framework/icejs/plugins/entryHtml.ts b/packages/code-generator/src/plugins/project/framework/icejs/plugins/entryHtml.ts
index a0ca3cdf1..e5837a8dd 100644
--- a/packages/code-generator/src/plugins/project/framework/icejs/plugins/entryHtml.ts
+++ b/packages/code-generator/src/plugins/project/framework/icejs/plugins/entryHtml.ts
@@ -28,10 +28,10 @@ const pluginFactory: BuilderComponentPluginFactory<unknown> = () => {
             <meta charset="utf-8" />
             <meta http-equiv="x-ua-compatible" content="ie=edge,chrome=1" />
             <meta name="viewport" content="width=device-width" />
-            <title>${ir.meta.name}</title>
+            <title>${ir?.meta?.name || 'Ice App'}</title>
           </head>
           <body>
-            <div id="${ir.config.targetRootID}"></div>
+            <div id="app"></div>
           </body>
         </html>
       `,
diff --git a/packages/code-generator/src/plugins/project/framework/icejs/plugins/packageJSON.ts b/packages/code-generator/src/plugins/project/framework/icejs/plugins/packageJSON.ts
index f238b6af0..c3eb5198d 100644
--- a/packages/code-generator/src/plugins/project/framework/icejs/plugins/packageJSON.ts
+++ b/packages/code-generator/src/plugins/project/framework/icejs/plugins/packageJSON.ts
@@ -1,3 +1,5 @@
+import { PackageJSON } from '@ali/lowcode-types';
+
 import { COMMON_CHUNK_NAME } from '../../../../../const/generator';
 
 import {
@@ -6,11 +8,10 @@ import {
   ChunkType,
   FileType,
   ICodeStruct,
-  IPackageJSON,
   IProjectInfo,
 } from '../../../../../types';
 
-interface IIceJsPackageJSON extends IPackageJSON {
+interface IIceJsPackageJSON extends PackageJSON {
   ideMode: {
     name: string;
   };
@@ -73,7 +74,9 @@ const pluginFactory: BuilderComponentPluginFactory<unknown> = () => {
       originTemplate: '@alifd/scaffold-lite-js',
     };
 
-    ir.packages.forEach((packageInfo) => (packageJson.dependencies[packageInfo.package] = packageInfo.version));
+    ir.packages.forEach((packageInfo) => {
+      packageJson.dependencies[packageInfo.package] = packageInfo.version;
+    });
 
     next.chunks.push({
       type: ChunkType.JSON,
diff --git a/packages/code-generator/src/plugins/project/framework/icejs/plugins/router.ts b/packages/code-generator/src/plugins/project/framework/icejs/plugins/router.ts
index bb2d7c47f..0e2e8c1f7 100644
--- a/packages/code-generator/src/plugins/project/framework/icejs/plugins/router.ts
+++ b/packages/code-generator/src/plugins/project/framework/icejs/plugins/router.ts
@@ -39,7 +39,7 @@ const pluginFactory: BuilderComponentPluginFactory<unknown> = () => {
             children: [
               ${ir.routes
     .map(
-      route => `
+      (route) => `
                     {
                       path: '${route.path}',
                       component: ${route.componentName},
@@ -54,6 +54,7 @@ const pluginFactory: BuilderComponentPluginFactory<unknown> = () => {
       linkAfter: [
         COMMON_CHUNK_NAME.ExternalDepsImport,
         COMMON_CHUNK_NAME.InternalDepsImport,
+        COMMON_CHUNK_NAME.ImportAliasDefine,
         COMMON_CHUNK_NAME.FileUtilDefine,
       ],
     });
@@ -69,6 +70,7 @@ const pluginFactory: BuilderComponentPluginFactory<unknown> = () => {
         COMMON_CHUNK_NAME.ExternalDepsImport,
         COMMON_CHUNK_NAME.InternalDepsImport,
         COMMON_CHUNK_NAME.FileUtilDefine,
+        COMMON_CHUNK_NAME.ImportAliasDefine,
         COMMON_CHUNK_NAME.FileVarDefine,
         COMMON_CHUNK_NAME.FileMainContent,
       ],
diff --git a/packages/code-generator/src/plugins/project/framework/rax/index.ts b/packages/code-generator/src/plugins/project/framework/rax/index.ts
new file mode 100644
index 000000000..a17e82132
--- /dev/null
+++ b/packages/code-generator/src/plugins/project/framework/rax/index.ts
@@ -0,0 +1,19 @@
+import template from './template';
+import entry from './plugins/entry';
+import appConfig from './plugins/appConfig';
+import buildConfig from './plugins/buildConfig';
+import entryDocument from './plugins/entryDocument';
+import globalStyle from './plugins/globalStyle';
+import packageJSON from './plugins/packageJSON';
+
+export default {
+  template,
+  plugins: {
+    appConfig,
+    buildConfig,
+    entry,
+    entryDocument,
+    globalStyle,
+    packageJSON,
+  },
+};
diff --git a/packages/code-generator/src/plugins/project/framework/rax/plugins/appConfig.ts b/packages/code-generator/src/plugins/project/framework/rax/plugins/appConfig.ts
new file mode 100644
index 000000000..354e5f93c
--- /dev/null
+++ b/packages/code-generator/src/plugins/project/framework/rax/plugins/appConfig.ts
@@ -0,0 +1,46 @@
+import changeCase from 'change-case';
+import { COMMON_CHUNK_NAME } from '../../../../../const/generator';
+
+import {
+  BuilderComponentPlugin,
+  BuilderComponentPluginFactory,
+  ChunkType,
+  FileType,
+  ICodeStruct,
+  IParseResult,
+} from '../../../../../types';
+
+const pluginFactory: BuilderComponentPluginFactory<unknown> = () => {
+  const plugin: BuilderComponentPlugin = async (pre: ICodeStruct) => {
+    const next: ICodeStruct = {
+      ...pre,
+    };
+
+    const ir = next.ir as IParseResult;
+
+    const routes = ir.globalRouter?.routes?.map((route) => ({
+      path: route.path,
+      source: `pages/${changeCase.pascalCase(route.fileName)}/index`,
+    })) || [{ path: '/', source: 'pages/Home/index' }];
+
+    next.chunks.push({
+      type: ChunkType.STRING,
+      fileType: FileType.JSON,
+      name: COMMON_CHUNK_NAME.CustomContent,
+      content: `
+{
+  "routes": ${JSON.stringify(routes, null, 2)},
+  "window": {
+    "title": ${JSON.stringify(ir.project?.meta?.title || ir.project?.meta?.name || '')}
+  }
+}
+      `,
+      linkAfter: [],
+    });
+
+    return next;
+  };
+  return plugin;
+};
+
+export default pluginFactory;
diff --git a/packages/code-generator/src/plugins/project/framework/rax/plugins/buildConfig.ts b/packages/code-generator/src/plugins/project/framework/rax/plugins/buildConfig.ts
new file mode 100644
index 000000000..070db3ee3
--- /dev/null
+++ b/packages/code-generator/src/plugins/project/framework/rax/plugins/buildConfig.ts
@@ -0,0 +1,52 @@
+import { COMMON_CHUNK_NAME } from '../../../../../const/generator';
+
+import {
+  BuilderComponentPlugin,
+  BuilderComponentPluginFactory,
+  ChunkType,
+  FileType,
+  ICodeStruct,
+  IParseResult,
+} from '../../../../../types';
+
+const pluginFactory: BuilderComponentPluginFactory<unknown> = () => {
+  const plugin: BuilderComponentPlugin = async (pre: ICodeStruct) => {
+    const next: ICodeStruct = {
+      ...pre,
+    };
+
+    const ir = next.ir as IParseResult;
+    const miniAppBuildType = ir.project?.config.miniAppBuildType;
+
+    const buildCfg = {
+      inlineStyle: false,
+      plugins: [
+        [
+          'build-plugin-rax-app',
+          {
+            targets: ['web', 'miniapp'],
+            miniapp: miniAppBuildType
+              ? {
+                buildType: miniAppBuildType,
+              }
+              : undefined,
+          },
+        ],
+        '@ali/build-plugin-rax-app-def',
+      ],
+    };
+
+    next.chunks.push({
+      type: ChunkType.STRING,
+      fileType: FileType.JSON,
+      name: COMMON_CHUNK_NAME.CustomContent,
+      content: JSON.stringify(buildCfg, null, 2) + '\n',
+      linkAfter: [],
+    });
+
+    return next;
+  };
+  return plugin;
+};
+
+export default pluginFactory;
diff --git a/packages/code-generator/src/plugins/project/framework/rax/plugins/entry.ts b/packages/code-generator/src/plugins/project/framework/rax/plugins/entry.ts
new file mode 100644
index 000000000..bea52e2af
--- /dev/null
+++ b/packages/code-generator/src/plugins/project/framework/rax/plugins/entry.ts
@@ -0,0 +1,51 @@
+import { COMMON_CHUNK_NAME } from '../../../../../const/generator';
+
+import {
+  BuilderComponentPlugin,
+  BuilderComponentPluginFactory,
+  ChunkType,
+  FileType,
+  ICodeStruct,
+} from '../../../../../types';
+
+const pluginFactory: BuilderComponentPluginFactory<unknown> = () => {
+  const plugin: BuilderComponentPlugin = async (pre: ICodeStruct) => {
+    const next: ICodeStruct = {
+      ...pre,
+    };
+
+    next.chunks.push({
+      type: ChunkType.STRING,
+      fileType: FileType.JS,
+      name: COMMON_CHUNK_NAME.ExternalDepsImport,
+      content: `
+import { runApp } from 'rax-app';
+import appConfig from './app.json';
+
+import './global.scss';
+`,
+      linkAfter: [],
+    });
+
+    next.chunks.push({
+      type: ChunkType.STRING,
+      fileType: FileType.JS,
+      name: COMMON_CHUNK_NAME.FileMainContent,
+      content: `
+runApp(appConfig);
+`,
+      linkAfter: [
+        COMMON_CHUNK_NAME.ExternalDepsImport,
+        COMMON_CHUNK_NAME.InternalDepsImport,
+        COMMON_CHUNK_NAME.ImportAliasDefine,
+        COMMON_CHUNK_NAME.FileVarDefine,
+        COMMON_CHUNK_NAME.FileUtilDefine,
+      ],
+    });
+
+    return next;
+  };
+  return plugin;
+};
+
+export default pluginFactory;
diff --git a/packages/code-generator/src/plugins/project/framework/rax/plugins/entryDocument.ts b/packages/code-generator/src/plugins/project/framework/rax/plugins/entryDocument.ts
new file mode 100644
index 000000000..cb5240139
--- /dev/null
+++ b/packages/code-generator/src/plugins/project/framework/rax/plugins/entryDocument.ts
@@ -0,0 +1,59 @@
+import { COMMON_CHUNK_NAME } from '../../../../../const/generator';
+
+import {
+  BuilderComponentPlugin,
+  BuilderComponentPluginFactory,
+  ChunkType,
+  FileType,
+  ICodeStruct,
+  IProjectInfo,
+} from '../../../../../types';
+
+const pluginFactory: BuilderComponentPluginFactory<unknown> = () => {
+  const plugin: BuilderComponentPlugin = async (pre: ICodeStruct) => {
+    const next: ICodeStruct = {
+      ...pre,
+    };
+
+    const ir = next.ir as IProjectInfo;
+
+    next.chunks.push({
+      type: ChunkType.STRING,
+      fileType: FileType.JSX,
+      name: COMMON_CHUNK_NAME.CustomContent,
+      content: `
+import { createElement } from 'rax';
+import { Root, Style, Script } from 'rax-document';
+
+function Document() {
+  return (
+    <html>
+      <head>
+        <meta charset="utf-8" />
+        <meta
+          name="viewport"
+          content="width=device-width,initial-scale=1,maximum-scale=1,minimum-scale=1,user-scalable=no,viewport-fit=cover"
+        />
+        <title>${ir?.meta?.name || 'Rax App'}</title>
+        <Style />
+      </head>
+      <body>
+        {/* root container */}
+        <Root />
+        <Script />
+      </body>
+    </html>
+  );
+}
+
+export default Document;
+`,
+      linkAfter: [],
+    });
+
+    return next;
+  };
+  return plugin;
+};
+
+export default pluginFactory;
diff --git a/packages/code-generator/src/plugins/project/framework/rax/plugins/globalStyle.ts b/packages/code-generator/src/plugins/project/framework/rax/plugins/globalStyle.ts
new file mode 100644
index 000000000..335fc4ffe
--- /dev/null
+++ b/packages/code-generator/src/plugins/project/framework/rax/plugins/globalStyle.ts
@@ -0,0 +1,64 @@
+import { COMMON_CHUNK_NAME } from '../../../../../const/generator';
+
+import {
+  BuilderComponentPlugin,
+  BuilderComponentPluginFactory,
+  ChunkType,
+  FileType,
+  ICodeStruct,
+  IProjectInfo,
+} from '../../../../../types';
+
+export type GlobalStylePluginConfig = {
+  fileType: string;
+};
+
+const pluginFactory: BuilderComponentPluginFactory<GlobalStylePluginConfig> = (
+  config?: Partial<GlobalStylePluginConfig>,
+) => {
+  const cfg: GlobalStylePluginConfig = {
+    fileType: FileType.SCSS,
+    ...config,
+  };
+
+  const plugin: BuilderComponentPlugin = async (pre: ICodeStruct) => {
+    const next: ICodeStruct = {
+      ...pre,
+    };
+
+    const ir = next.ir as IProjectInfo;
+
+    next.chunks.push({
+      type: ChunkType.STRING,
+      fileType: cfg.fileType,
+      name: COMMON_CHUNK_NAME.StyleDepsImport,
+      content: '',
+      linkAfter: [],
+    });
+
+    next.chunks.push({
+      type: ChunkType.STRING,
+      fileType: cfg.fileType,
+      name: COMMON_CHUNK_NAME.StyleCssContent,
+      content: `
+body {
+  -webkit-font-smoothing: antialiased;
+}
+`,
+      linkAfter: [COMMON_CHUNK_NAME.StyleDepsImport],
+    });
+
+    next.chunks.push({
+      type: ChunkType.STRING,
+      fileType: cfg.fileType,
+      name: COMMON_CHUNK_NAME.StyleCssContent,
+      content: ir.css || '',
+      linkAfter: [COMMON_CHUNK_NAME.StyleDepsImport],
+    });
+
+    return next;
+  };
+  return plugin;
+};
+
+export default pluginFactory;
diff --git a/packages/code-generator/src/plugins/project/framework/rax/plugins/packageJSON.ts b/packages/code-generator/src/plugins/project/framework/rax/plugins/packageJSON.ts
new file mode 100644
index 000000000..b834a2855
--- /dev/null
+++ b/packages/code-generator/src/plugins/project/framework/rax/plugins/packageJSON.ts
@@ -0,0 +1,115 @@
+import { NpmInfo, PackageJSON } from '@ali/lowcode-types';
+import { COMMON_CHUNK_NAME } from '../../../../../const/generator';
+
+import {
+  BuilderComponentPlugin,
+  BuilderComponentPluginFactory,
+  ChunkType,
+  FileType,
+  ICodeStruct,
+  IProjectInfo,
+} from '../../../../../types';
+import { isNpmInfo } from '../../../../../utils/schema';
+import { calcCompatibleVersion } from '../../../../../utils/version';
+
+const pluginFactory: BuilderComponentPluginFactory<unknown> = () => {
+  const plugin: BuilderComponentPlugin = async (pre: ICodeStruct) => {
+    const next: ICodeStruct = {
+      ...pre,
+    };
+
+    const ir = next.ir as IProjectInfo;
+
+    const npmDeps = getNpmDependencies(ir);
+
+    const packageJson: PackageJSON = {
+      name: '@ali/rax-app-demo',
+      private: true,
+      version: '1.0.0',
+      scripts: {
+        build: 'build-scripts build',
+        start: 'build-scripts start',
+        lint: 'eslint --ext .js --ext .jsx ./',
+      },
+      dependencies: {
+        '@ali/lowcode-datasource-engine': '*',
+        // TODO: 如何动态获取下面这些依赖？
+        '@ali/lowcode-datasource-url-params-handler': '*',
+        '@ali/lowcode-datasource-fetch-handler': '*',
+        '@ali/lowcode-datasource-mtop-handler': '*',
+        '@ali/lowcode-datasource-mopen-handler': '*',
+        'universal-env': '^3.2.0',
+        'intl-messageformat': '^9.3.6',
+        rax: '^1.1.0',
+        'rax-app': '^2.0.0',
+        'rax-document': '^0.1.0',
+        ...npmDeps.reduce(
+          (acc, npm) => ({
+            ...acc,
+            [npm.package]: npm.version || '*',
+          }),
+          {} as Record<string, string>,
+        ),
+      },
+      devDependencies: {
+        'build-plugin-rax-app': '^5.0.0',
+        '@alib/build-scripts': '^0.1.0',
+        '@typescript-eslint/eslint-plugin': '^2.11.0',
+        '@typescript-eslint/parser': '^2.11.0',
+        'babel-eslint': '^10.0.3',
+        eslint: '^6.8.0',
+        'eslint-config-rax': '^0.1.0',
+        'eslint-plugin-import': '^2.20.0',
+        'eslint-plugin-module': '^0.1.0',
+        'eslint-plugin-react': '^7.18.0',
+        '@ali/build-plugin-rax-app-def': '^1.0.0',
+      },
+    };
+
+    next.chunks.push({
+      type: ChunkType.JSON,
+      fileType: FileType.JSON,
+      name: COMMON_CHUNK_NAME.FileMainContent,
+      content: packageJson,
+      linkAfter: [],
+    });
+
+    return next;
+  };
+  return plugin;
+};
+
+export default pluginFactory;
+
+function getNpmDependencies(project: IProjectInfo): NpmInfo[] {
+  const npmDeps: NpmInfo[] = [];
+  const npmNameToPkgMap = new Map<string, NpmInfo>();
+
+  const allDeps = [...(project.containersDeps || []), ...(project.utilsDeps || [])];
+
+  allDeps.forEach((dep) => {
+    if (!isNpmInfo(dep)) {
+      return;
+    }
+
+    const existing = npmNameToPkgMap.get(dep.package);
+    if (!existing) {
+      npmNameToPkgMap.set(dep.package, dep);
+      npmDeps.push(dep);
+      return;
+    }
+
+    if (existing.version !== dep.version) {
+      try {
+        npmNameToPkgMap.set(dep.package, {
+          ...existing,
+          version: calcCompatibleVersion(existing.version, dep.version),
+        });
+      } catch (e) {
+        throw new Error(`Cannot find compatible version for ${dep.package}. Detail: ${e.message}`);
+      }
+    }
+  });
+
+  return npmDeps;
+}
diff --git a/packages/code-generator/src/plugins/project/i18n.ts b/packages/code-generator/src/plugins/project/i18n.ts
index 4e4675a04..eaac073c8 100644
--- a/packages/code-generator/src/plugins/project/i18n.ts
+++ b/packages/code-generator/src/plugins/project/i18n.ts
@@ -1,5 +1,5 @@
 import { COMMON_CHUNK_NAME } from '../../const/generator';
-import { generateCompositeType } from '../../utils/compositeType';
+
 import {
   BuilderComponentPlugin,
   BuilderComponentPluginFactory,
@@ -16,51 +16,73 @@ const pluginFactory: BuilderComponentPluginFactory<unknown> = () => {
     };
 
     const ir = next.ir as IProjectInfo;
-    if (ir.i18n) {
-      const i18nStr = generateCompositeType(ir.i18n);
+    const i18nStr = ir.i18n ? JSON.stringify(ir.i18n, null, 2) : '{}';
 
-      next.chunks.push({
-        type: ChunkType.STRING,
-        fileType: FileType.JS,
-        name: COMMON_CHUNK_NAME.FileMainContent,
-        content: `
-          const i18nConfig = ${i18nStr};
-          let locale = 'en_US';
+    next.chunks.push({
+      type: ChunkType.STRING,
+      fileType: FileType.JS,
+      name: COMMON_CHUNK_NAME.FileMainContent,
+      content: `
+        import IntlMessageFormat from 'intl-messageformat';
 
-          const changeLocale = (target) => {
-            locale = target;
-          };
+        const i18nConfig = ${i18nStr};
 
-          const i18n = key => i18nConfig && i18nConfig[locale] && i18nConfig[locale][key] || '';
-        `,
-        linkAfter: [
-          COMMON_CHUNK_NAME.ExternalDepsImport,
-          COMMON_CHUNK_NAME.InternalDepsImport,
-          COMMON_CHUNK_NAME.FileVarDefine,
-          COMMON_CHUNK_NAME.FileUtilDefine,
-        ],
-      });
+        let locale = 'en-US';
 
-      next.chunks.push({
-        type: ChunkType.STRING,
-        fileType: FileType.JS,
-        name: COMMON_CHUNK_NAME.FileExport,
-        content: `
-          export {
-            changeLocale,
-            i18n,
-          };
-        `,
-        linkAfter: [
-          COMMON_CHUNK_NAME.ExternalDepsImport,
-          COMMON_CHUNK_NAME.InternalDepsImport,
-          COMMON_CHUNK_NAME.FileVarDefine,
-          COMMON_CHUNK_NAME.FileUtilDefine,
-          COMMON_CHUNK_NAME.FileMainContent,
-        ],
-      });
-    }
+        const getLocale = () => locale;
 
+        const setLocale = (target) => {
+          locale = target;
+        };
+
+        const i18nFormat = ({ id, defaultMessage }, variables) => {
+          const msg = i18nConfig && i18nConfig[locale] && i18nConfig[locale][id] || defaultMessage;
+          if (msg == null) {
+            console.warn('[i18n]: unknown message id: %o (locale=%o)', id, locale);
+            return \`\${id}\`;
+          }
+
+          if (!variables || !variables.length) {
+            return msg;
+          }
+
+          return new IntlMessageFormat(msg, locale).format(variables);
+        }
+
+        const i18n = id => {
+          return i18nFormat({ id });
+        };
+      `,
+      linkAfter: [
+        COMMON_CHUNK_NAME.ExternalDepsImport,
+        COMMON_CHUNK_NAME.InternalDepsImport,
+        COMMON_CHUNK_NAME.ImportAliasDefine,
+        COMMON_CHUNK_NAME.FileVarDefine,
+        COMMON_CHUNK_NAME.FileUtilDefine,
+      ],
+    });
+
+    next.chunks.push({
+      type: ChunkType.STRING,
+      fileType: FileType.JS,
+      name: COMMON_CHUNK_NAME.FileExport,
+      content: `
+        export {
+          getLocale,
+          setLocale,
+          i18n,
+          i18nFormat,
+        };
+      `,
+      linkAfter: [
+        COMMON_CHUNK_NAME.ExternalDepsImport,
+        COMMON_CHUNK_NAME.InternalDepsImport,
+        COMMON_CHUNK_NAME.ImportAliasDefine,
+        COMMON_CHUNK_NAME.FileVarDefine,
+        COMMON_CHUNK_NAME.FileUtilDefine,
+        COMMON_CHUNK_NAME.FileMainContent,
+      ],
+    });
     return next;
   };
   return plugin;
diff --git a/packages/code-generator/src/plugins/project/utils.ts b/packages/code-generator/src/plugins/project/utils.ts
index 32e7c5d17..5cdb21e81 100644
--- a/packages/code-generator/src/plugins/project/utils.ts
+++ b/packages/code-generator/src/plugins/project/utils.ts
@@ -28,24 +28,26 @@ const pluginFactory: BuilderComponentPluginFactory<unknown> = () => {
         linkAfter: [
           COMMON_CHUNK_NAME.ExternalDepsImport,
           COMMON_CHUNK_NAME.InternalDepsImport,
+          COMMON_CHUNK_NAME.ImportAliasDefine,
           COMMON_CHUNK_NAME.FileVarDefine,
           COMMON_CHUNK_NAME.FileUtilDefine,
           COMMON_CHUNK_NAME.FileMainContent,
         ],
       });
 
-      ir.utils.forEach(util => {
+      ir.utils.forEach((util) => {
         if (util.type === 'function') {
           next.chunks.push({
             type: ChunkType.STRING,
             fileType: FileType.JS,
             name: COMMON_CHUNK_NAME.FileVarDefine,
             content: `
-              const ${util.name} = ${util.content};
+              const ${util.name} = ${util.content.value};
             `,
             linkAfter: [
               COMMON_CHUNK_NAME.ExternalDepsImport,
               COMMON_CHUNK_NAME.InternalDepsImport,
+              COMMON_CHUNK_NAME.ImportAliasDefine,
             ],
           });
         }
@@ -54,12 +56,11 @@ const pluginFactory: BuilderComponentPluginFactory<unknown> = () => {
           type: ChunkType.STRING,
           fileType: FileType.JS,
           name: COMMON_CHUNK_NAME.FileExport,
-          content: `
-            ${util.name},
-          `,
+          content: `${util.name},`,
           linkAfter: [
             COMMON_CHUNK_NAME.ExternalDepsImport,
             COMMON_CHUNK_NAME.InternalDepsImport,
+            COMMON_CHUNK_NAME.ImportAliasDefine,
             COMMON_CHUNK_NAME.FileVarDefine,
             COMMON_CHUNK_NAME.FileUtilDefine,
             COMMON_CHUNK_NAME.FileMainContent,
@@ -77,6 +78,7 @@ const pluginFactory: BuilderComponentPluginFactory<unknown> = () => {
         linkAfter: [
           COMMON_CHUNK_NAME.ExternalDepsImport,
           COMMON_CHUNK_NAME.InternalDepsImport,
+          COMMON_CHUNK_NAME.ImportAliasDefine,
           COMMON_CHUNK_NAME.FileVarDefine,
           COMMON_CHUNK_NAME.FileUtilDefine,
           COMMON_CHUNK_NAME.FileMainContent,
diff --git a/packages/code-generator/src/postprocessor/prettier/index.ts b/packages/code-generator/src/postprocessor/prettier/index.ts
index 082a3d022..6cdd63d20 100644
--- a/packages/code-generator/src/postprocessor/prettier/index.ts
+++ b/packages/code-generator/src/postprocessor/prettier/index.ts
@@ -21,6 +21,8 @@ const factory: PostProcessorFactory<ProcessorConfig> = (config?: ProcessorConfig
       parser = 'babel';
     } else if (fileType === 'ts' || fileType === 'tsx') {
       parser = 'typescript';
+    } else if (fileType === 'json') {
+      parser = 'json';
     } else if (PARSERS.indexOf(fileType) >= 0) {
       parser = fileType as prettier.BuiltInParserName;
     } else if (cfg.customFileTypeParser[fileType]) {
diff --git a/packages/code-generator/src/publisher/disk/index.ts b/packages/code-generator/src/publisher/disk/index.ts
index bc12ed96f..189dff7e3 100644
--- a/packages/code-generator/src/publisher/disk/index.ts
+++ b/packages/code-generator/src/publisher/disk/index.ts
@@ -1,16 +1,14 @@
-import {
-  IResultDir,
-  PublisherFactory,
-  IPublisher,
-  IPublisherFactoryParams,
-  PublisherError,
-} from '../../types';
-import { writeFolder } from './utils';
+import * as defaultFs from 'fs';
+
+import { ResultDir } from '@ali/lowcode-types';
+import { PublisherFactory, IPublisher, IPublisherFactoryParams, PublisherError } from '../../types';
+import { writeFolder, IFileSystem } from './utils';
 
 export interface IDiskFactoryParams extends IPublisherFactoryParams {
   outputPath?: string;
   projectSlug?: string;
   createProjectFolder?: boolean;
+  fs?: IFileSystem;
 }
 
 export interface IDiskPublisher extends IPublisher<IDiskFactoryParams, string> {
@@ -18,19 +16,19 @@ export interface IDiskPublisher extends IPublisher<IDiskFactoryParams, string> {
   setOutputPath: (path: string) => void;
 }
 
-export const createDiskPublisher: PublisherFactory<
-IDiskFactoryParams,
-IDiskPublisher
-> = (params: IDiskFactoryParams = {}): IDiskPublisher => {
+export const createDiskPublisher: PublisherFactory<IDiskFactoryParams, IDiskPublisher> = (
+  params: IDiskFactoryParams = {},
+): IDiskPublisher => {
   let { project, outputPath = './' } = params;
+  const { fs = defaultFs } = params;
 
-  const getProject = (): IResultDir => {
+  const getProject = (): ResultDir => {
     if (!project) {
       throw new PublisherError('Missing Project');
     }
     return project;
   };
-  const setProject = (projectToSet: IResultDir): void => {
+  const setProject = (projectToSet: ResultDir): void => {
     project = projectToSet;
   };
 
@@ -49,19 +47,14 @@ IDiskPublisher
 
     const projectOutputPath = options.outputPath || outputPath;
     const overrideProjectSlug = options.projectSlug || params.projectSlug;
-    const createProjectFolder =
-      options.createProjectFolder || params.createProjectFolder;
+    const createProjectFolder = options.createProjectFolder || params.createProjectFolder;
 
     if (overrideProjectSlug) {
       projectToPublish.name = overrideProjectSlug;
     }
 
     try {
-      await writeFolder(
-        projectToPublish,
-        projectOutputPath,
-        createProjectFolder,
-      );
+      await writeFolder(projectToPublish, projectOutputPath, createProjectFolder, fs);
       return { success: true, payload: projectOutputPath };
     } catch (error) {
       throw new PublisherError(error);
